*
* Test file to demonstrate instructions and addressing modes of: Z80
*
IMM	EQU	$12
EXT	EQU	$3445
*
	ADC	A,(HL)		;8 bit Add with carry
	ADC	A,(IX+01)
	ADC	A,(IY+01)
	ADC	A,A
	ADC	A,B
	ADC	A,C
	ADC	A,D
	ADC	A,E
	ADC	A,H
	ADC	A,L
	ADC	A,imm
	ADC	HL,BC		;16 bit add with carry
	ADC	HL,DE
	ADC	HL,HL
	ADC	HL,SP
*
	ADD	A,(HL)		;8 bit add (no carry)
	ADD	A,(IX+01)
	ADD	A,(IY+01)
	ADD	A,A
	ADD	A,B
	ADD	A,C
	ADD	A,D
	ADD	A,E
	ADD	A,H
	ADD	A,L
	ADD	A,imm
*
	ADD	HL,BC		;16 bit add (no carry)
	ADD	HL,DE
	ADD	HL,HL
	ADD	HL,SP
*
	ADD	IX,BC
	ADD	IX,DE
	ADD	IX,IX
	ADD	IX,SP
*
	ADD	IY,BC
	ADD	IY,DE
	ADD	IY,IY
	ADD	IY,SP
*
	AND	(HL)		;8 bit logical AND
	AND	(IX+01)
	AND	(IY+01)
	AND	A
	AND	B
	AND	C
	AND	D
	AND	E
	AND	H
	AND	L
	AND	imm
*
	BIT	0,(HL)		;BIT test
	BIT	0,(IX+01)
	BIT	0,(IY+01)
	BIT	0,A
	BIT	0,B
	BIT	0,C
	BIT	0,D
	BIT	0,E
	BIT	0,H
	BIT	0,L
	BIT	1,(HL)
	BIT	1,(IX+01)
	BIT	1,(IY+01)
	BIT	1,A
	BIT	1,B
	BIT	1,C
	BIT	1,D
	BIT	1,E
	BIT	1,H
	BIT	1,L
	BIT	2,(HL)
	BIT	2,(IX+01)
	BIT	2,(IY+01)
	BIT	2,A
	BIT	2,B
	BIT	2,C
	BIT	2,D
	BIT	2,E
	BIT	2,H
	BIT	2,L
	BIT	3,(HL)
	BIT	3,(IX+01)
	BIT	3,(IY+01)
	BIT	3,A
	BIT	3,B
	BIT	3,C
	BIT	3,D
	BIT	3,E
	BIT	3,H
	BIT	3,L
	BIT	4,(HL)
	BIT	4,(IX+01)
	BIT	4,(IY+01)
	BIT	4,A
	BIT	4,B
	BIT	4,C
	BIT	4,D
	BIT	4,E
	BIT	4,H
	BIT	4,L
	BIT	5,(HL)
	BIT	5,(IX+01)
	BIT	5,(IY+01)
	BIT	5,A
	BIT	5,B
	BIT	5,C
	BIT	5,D
	BIT	5,E
	BIT	5,H
	BIT	5,L
	BIT	6,(HL)
	BIT	6,(IX+01)
	BIT	6,(IY+01)
	BIT	6,A
	BIT	6,B
	BIT	6,C
	BIT	6,D
	BIT	6,E
	BIT	6,H
	BIT	6,L
	BIT	7,(HL)
	BIT	7,(IX+01)
	BIT	7,(IY+01)
	BIT	7,A
	BIT	7,B
	BIT	7,C
	BIT	7,D
	BIT	7,E
	BIT	7,H
	BIT	7,L
*
	CALL	C,ext		;Conditional call
	CALL	M,ext
	CALL	NC,ext
	CALL	NZ,ext
	CALL	P,ext
	CALL	PE,ext
	CALL	PO,ext
	CALL	Z,ext
*
	CALL	ext		;Unconditional call
*
	CP	(HL)		;8 bit compare
	CP	(IX+01)
	CP	(IY+01)
	CP	A
	CP	B
	CP	C
	CP	D
	CP	E
	CP	H
	CP	L
	CP	imm
*
	DEC	(HL)		;8/16 bit decrements
	DEC	(IX+01)
	DEC	(IY+01)
	DEC	A
	DEC	B
	DEC	BC
	DEC	C
	DEC	D
	DEC	DE
	DEC	E
	DEC	H
	DEC	HL
	DEC	IX
	DEC	IY
	DEC	L
	DEC	SP
*
	DJNZ	*		;if(--B) jump
*
	EX	(SP),HL		;16 bit exchanges
	EX	(SP),IX
	EX	(SP),IY
	EX	DE,HL
	EX	AF,AF'
	EXX			;Aux register exchange (BC/DE/HL)
*
	IM	0		;Set interrupt mode (0/1/2)
	IM	1
	IM	2
*
	IN	A,(imm)		;Input from I/O port
	IN	A,(C)
	IN	B,(C)
	IN	C,(C)
	IN	D,(C)
	IN	E,(C)
	IN	H,(C)
	IN	L,(C)
*
	INC	(HL)		;8/16 bit increments
	INC	(IX+01)
	INC	(IY+01)
	INC	A
	INC	B
	INC	BC
	INC	C
	INC	D
	INC	DE
	INC	E
	INC	H
	INC	HL
	INC	IX
	INC	IY
	INC	L
	INC	SP
*
	JP	ext		;Long (absolute) jumps
	JP	(HL)
	JP	(IX)
	JP	(IY)
	JP	C,ext
	JP	M,ext
	JP	NC,ext
	JP	NZ,ext
	JP	P,ext
	JP	PE,ext
	JP	PO,ext
	JP	Z,ext
*
	JR	C,*		;Short (relative) jumps
	JR	NC,*
	JR	NZ,*
	JR	Z,*
	JR	*
*
	LD	(BC),A		;8/16 bit loads
	LD	(DE),A
	LD	(HL),A
	LD	(HL),B
	LD	(HL),C
	LD	(HL),D
	LD	(HL),E
	LD	(HL),H
	LD	(HL),L
	LD	(HL),imm
	LD	(IX+01),A
	LD	(IX+01),B
	LD	(IX+01),C
	LD	(IX+01),D
	LD	(IX+01),E
	LD	(IX+01),H
	LD	(IX+01),L
	LD	(IX+01),imm
	LD	(IY+01),A
	LD	(IY+01),B
	LD	(IY+01),C
	LD	(IY+01),D
	LD	(IY+01),E
	LD	(IY+01),H
	LD	(IY+01),L
	LD	(IY+01),imm
	LD	(ext),A
	LD	(ext),BC
	LD	(ext),DE
	LD	(ext),HL
	LD	(ext),IX
	LD	(ext),IY
	LD	(ext),SP
	LD	A,(BC)
	LD	A,(DE)
	LD	A,(HL)
	LD	A,(IX+01)
	LD	A,(IY+01)
	LD	A,(ext)
	LD	A,A
	LD	A,B
	LD	A,C
	LD	A,D
	LD	A,E
	LD	A,H
	LD	A,I
	LD	A,L
	LD	A,imm
	LD	A,R
	LD	B,(HL)
	LD	B,(IX+01)
	LD	B,(IY+01)
	LD	B,A
	LD	B,B
	LD	B,C
	LD	B,D
	LD	B,E
	LD	B,H
	LD	B,L
	LD	B,imm
	LD	BC,(ext)
	LD	BC,ext
	LD	C,(HL)
	LD	C,(IX+01)
	LD	C,(IY+01)
	LD	C,A
	LD	C,B
	LD	C,C
	LD	C,D
	LD	C,E
	LD	C,H
	LD	C,L
	LD	C,imm
	LD	D,(HL)
	LD	D,(IX+01)
	LD	D,(IY+01)
	LD	D,A
	LD	D,B
	LD	D,C
	LD	D,D
	LD	D,E
	LD	D,H
	LD	D,L
	LD	D,imm
	LD	DE,(ext)
	LD	DE,ext
	LD	E,(HL)
	LD	E,(IX+01)
	LD	E,(IY+01)
	LD	E,A
	LD	E,B
	LD	E,C
	LD	E,D
	LD	E,E
	LD	E,H
	LD	E,L
	LD	E,imm
	LD	H,(HL)
	LD	H,(IX+01)
	LD	H,(IY+01)
	LD	H,A
	LD	H,B
	LD	H,C
	LD	H,D
	LD	H,E
	LD	H,H
	LD	H,L
	LD	H,imm
	LD	HL,(ext)
	LD	HL,ext
	LD	I,A
	LD	IX,(ext)
	LD	IX,ext
	LD	IY,(ext)
	LD	IY,ext
	LD	L,(HL)
	LD	L,(IX+01)
	LD	L,(IY+01)
	LD	L,A
	LD	L,B
	LD	L,C
	LD	L,D
	LD	L,E
	LD	L,H
	LD	L,L
	LD	L,imm
	LD	R,A
	LD	SP,(ext)
	LD	SP,HL
	LD	SP,IX
	LD	SP,IY
	LD	SP,ext
*
	OR	(HL)		;8 bit logical OR
	OR	(IX+01)
	OR	(IY+01)
	OR	A
	OR	B
	OR	C
	OR	D
	OR	E
	OR	H
	OR	L
	OR	imm
*
	OUT	(imm),A		;Output to I/O port
	OUT	(C),A
	OUT	(C),B
	OUT	(C),C
	OUT	(C),D
	OUT	(C),E
	OUT	(C),H
	OUT	(C),L
*
	POP	AF		;Pop registers from stack
	POP	BC
	POP	DE
	POP	HL
	POP	IX
	POP	IY
*
	PUSH	AF		;Push registers to stack
	PUSH	BC
	PUSH	DE
	PUSH	HL
	PUSH	IX
	PUSH	IY
*
	RES	0,(HL)		;Reset bit
	RES	0,(IX+01)
	RES	0,(IY+01)
	RES	0,A
	RES	0,B
	RES	0,C
	RES	0,D
	RES	0,E
	RES	0,H
	RES	0,L
	RES	1,(HL)
	RES	1,(IX+01)
	RES	1,(IY+01)
	RES	1,A
	RES	1,B
	RES	1,C
	RES	1,D
	RES	1,E
	RES	1,H
	RES	1,L
	RES	2,(HL)
	RES	2,(IX+01)
	RES	2,(IY+01)
	RES	2,A
	RES	2,B
	RES	2,C
	RES	2,D
	RES	2,E
	RES	2,H
	RES	2,L
	RES	3,(HL)
	RES	3,(IX+01)
	RES	3,(IY+01)
	RES	3,A
	RES	3,B
	RES	3,C
	RES	3,D
	RES	3,E
	RES	3,H
	RES	3,L
	RES	4,(HL)
	RES	4,(IX+01)
	RES	4,(IY+01)
	RES	4,A
	RES	4,B
	RES	4,C
	RES	4,D
	RES	4,E
	RES	4,H
	RES	4,L
	RES	5,(HL)
	RES	5,(IX+01)
	RES	5,(IY+01)
	RES	5,A
	RES	5,B
	RES	5,C
	RES	5,D
	RES	5,E
	RES	5,H
	RES	5,L
	RES	6,(HL)
	RES	6,(IX+01)
	RES	6,(IY+01)
	RES	6,A
	RES	6,B
	RES	6,C
	RES	6,D
	RES	6,E
	RES	6,H
	RES	6,L
	RES	7,(HL)
	RES	7,(IX+01)
	RES	7,(IY+01)
	RES	7,A
	RES	7,B
	RES	7,C
	RES	7,D
	RES	7,E
	RES	7,H
	RES	7,L
*
	RET			;Standard/conditional returns
	RET	C
	RET	M
	RET	NC
	RET	NZ
	RET	P
	RET	PE
	RET	PO
	RET	Z
	RETI			;Return from interrupt
	RETN			;Return from NM interrupt
*
	RLA			;Rotate left (through carry)
	RL	(HL)
	RL	(IX+01)
	RL	(IY+01)
	RL	A
	RL	B
	RL	C
	RL	D
	RL	E
	RL	H
	RL	L
*
	RLCA			;Rotate left (bypass carry)
	RLC	(HL)
	RLC	(IX+01)
	RLC	(IY+01)
	RLC	A
	RLC	B
	RLC	C
	RLC	D
	RLC	E
	RLC	H
	RLC	L
*
	RRA			;Rotate right (through carry)
	RR	(HL)
	RR	(IX+01)
	RR	(IY+01)
	RR	A
	RR	B
	RR	C
	RR	D
	RR	E
	RR	H
	RR	L
*
	RRCA			;Rotate right (bypass carry)
	RRC	(HL)
	RRC	(IX+01)
	RRC	(IY+01)
	RRC	A
	RRC	B
	RRC	C
	RRC	D
	RRC	E
	RRC	H
	RRC	L
*
	RLD			;Digit rotate A[3-0] through (HL)
	RRD
*
	RST	00H		;Restart instructions
	RST	08H
	RST	10H
	RST	18H
	RST	20H
	RST	28H
	RST	30H
	RST	38H
*
	SBC	A,(HL)		;8 bit subtract with carry
	SBC	A,(IX+01)
	SBC	A,(IY+01)
	SBC	A,A
	SBC	A,B
	SBC	A,C
	SBC	A,D
	SBC	A,E
	SBC	A,H
	SBC	A,L
	SBC	A,imm
	SBC	HL,BC		;16 bit subtract with carry
	SBC	HL,DE
	SBC	HL,HL
	SBC	HL,SP
*
	SET	0,(HL)		;Bit set
	SET	0,(IX+01)
	SET	0,(IY+01)
	SET	0,A
	SET	0,B
	SET	0,C
	SET	0,D
	SET	0,E
	SET	0,H
	SET	0,L
	SET	1,(HL)
	SET	1,(IX+01)
	SET	1,(IY+01)
	SET	1,A
	SET	1,B
	SET	1,C
	SET	1,D
	SET	1,E
	SET	1,H
	SET	1,L
	SET	2,(HL)
	SET	2,(IX+01)
	SET	2,(IY+01)
	SET	2,A
	SET	2,B
	SET	2,C
	SET	2,D
	SET	2,E
	SET	2,H
	SET	2,L
	SET	3,(HL)
	SET	3,(IX+01)
	SET	3,(IY+01)
	SET	3,A
	SET	3,B
	SET	3,C
	SET	3,D
	SET	3,E
	SET	3,H
	SET	3,L
	SET	4,(HL)
	SET	4,(IX+01)
	SET	4,(IY+01)
	SET	4,A
	SET	4,B
	SET	4,C
	SET	4,D
	SET	4,E
	SET	4,H
	SET	4,L
	SET	5,(HL)
	SET	5,(IX+01)
	SET	5,(IY+01)
	SET	5,A
	SET	5,B
	SET	5,C
	SET	5,D
	SET	5,E
	SET	5,H
	SET	5,L
	SET	6,(HL)
	SET	6,(IX+01)
	SET	6,(IY+01)
	SET	6,A
	SET	6,B
	SET	6,C
	SET	6,D
	SET	6,E
	SET	6,H
	SET	6,L
	SET	7,(HL)
	SET	7,(IX+01)
	SET	7,(IY+01)
	SET	7,A
	SET	7,B
	SET	7,C
	SET	7,D
	SET	7,E
	SET	7,H
	SET	7,L
*
	SLA	(HL)		;Shift left (0 in)
	SLA	(IX+01)
	SLA	(IY+01)
	SLA	A
	SLA	B
	SLA	C
	SLA	D
	SLA	E
	SLA	H
	SLA	L
*
	SRA	(HL)		;Shift right (sign (A.7) in)
	SRA	(IX+01)
	SRA	(IY+01)
	SRA	A
	SRA	B
	SRA	C
	SRA	D
	SRA	E
	SRA	H
	SRA	L
*
	SRL	(HL)		;Shift right (0 in)
	SRL	(IX+01)
	SRL	(IY+01)
	SRL	A
	SRL	B
	SRL	C
	SRL	D
	SRL	E
	SRL	H
	SRL	L
*
	SUB	(HL)		;8 bit subtract
	SUB	(IX+01)
	SUB	(IY+01)
	SUB	A
	SUB	B
	SUB	C
	SUB	D
	SUB	E
	SUB	H
	SUB	L
	SUB	imm
*
	XOR	(HL)		;8 bit logical XOR
	XOR	(IX+01)
	XOR	(IY+01)
	XOR	A
	XOR	B
	XOR	C
	XOR	D
	XOR	E
	XOR	H
	XOR	L
	XOR	imm
*
	CCF			;Complement Carry Flag
	CPI			;(A == *HL++); --BC;
	CPIR			;while((A != *HL++) && !--BC);
	CPD			;(A == *HL--); --BC;
	CPDR			;while((A != *HL++) && !--BC);
	CPL			;Complement accumulator
	DAA			;Decimal adjust Accumulator
	DI			;Disable interrupts
	EI			;Enable interrupts
	HALT			;Stop CPU
	INI			;*HL++ = in(C); --B;
	INIR			;do *HL++ = in(C); while --B;
	IND			;*HL-- = in(C); --B;
	INDR			;do *HL-- = in(C); while --B;
	LDI			;*DE++ = *HL++; --BC;
	LDIR			;do *DE++ = *HL++; while --BC;
	LDD			;*DE-- = *DL--; --BC;
	LDDR			;do *DE--=*HL--; while --BC;
	NEG			;A = 0 - A
	NOP			;No operation
	OUTI			;out(C, *HL++); --B;
	OTIR			;do out(C, *HL++); while --B;
	OUTD			;out(C, *HL--); --B;
	OTDR			;do out(C, *HL--); while --B;
	SCF			;Set carry flag
